//
// Automatically generated by the IPDL compiler.
// Edit at your own risk
//

#ifndef PCrashReporter_h
#define PCrashReporter_h

#include "base/basictypes.h"
#include "prtime.h"
#include "nscore.h"
#include "IPCMessageStart.h"
#include "IPC/IPCMessageUtils.h"
#include "nsAutoPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "nsIFile.h"
#include "mozilla/ipc/ProtocolUtils.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct Mapping|
//
namespace mozilla {
namespace dom {
class NS_FINAL_CLASS Mapping
{
private:

public:
    Mapping();

    Mapping(
            const nsCString& _library_name,
            const nsCString& _file_id,
            const uintptr_t& _start_address,
            const size_t& _mapping_length,
            const size_t& _file_offset)
    {
        Init();
        Assign(_library_name, _file_id, _start_address, _mapping_length, _file_offset);
    }

    Mapping(const Mapping& _o)
    {
        Init();
        Assign((_o).library_name(), (_o).file_id(), (_o).start_address(), (_o).mapping_length(), (_o).file_offset());
    }

    ~Mapping();

    void
    operator=(const Mapping& _o)
    {
        Assign((_o).library_name(), (_o).file_id(), (_o).start_address(), (_o).mapping_length(), (_o).file_offset());
    }

    bool
    operator==(const Mapping& _o) const;

    nsCString&
    library_name()
    {
        return library_name_;
    }
    const nsCString&
    library_name() const
    {
        return library_name_;
    }

    nsCString&
    file_id()
    {
        return file_id_;
    }
    const nsCString&
    file_id() const
    {
        return file_id_;
    }

    uintptr_t&
    start_address()
    {
        return start_address_;
    }
    const uintptr_t&
    start_address() const
    {
        return start_address_;
    }

    size_t&
    mapping_length()
    {
        return mapping_length_;
    }
    const size_t&
    mapping_length() const
    {
        return mapping_length_;
    }

    size_t&
    file_offset()
    {
        return file_offset_;
    }
    const size_t&
    file_offset() const
    {
        return file_offset_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsCString& _library_name,
            const nsCString& _file_id,
            const uintptr_t& _start_address,
            const size_t& _mapping_length,
            const size_t& _file_offset);

    nsCString library_name_;
    nsCString file_id_;
    uintptr_t start_address_;
    size_t mapping_length_;
    size_t file_offset_;
};
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PCrashReporterChild and PCrashReporterParent
//
namespace mozilla {
namespace dom {
namespace PCrashReporter {

enum State {
    __Dead,
    __Null,
    __Error,
    __Start = __Null
};

enum MessageType {
    PCrashReporterStart = PCrashReporterMsgStart << 16,
    PCrashReporterPreStart = (PCrashReporterMsgStart << 16) - 1,
    Msg_AddLibraryMappings__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    PCrashReporterEnd
};

inline bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next)
{
    switch (from) {
    case __Null:
    case __Error:
        if ((Msg___delete____ID) == ((trigger).mMsg)) {
            (*(next)) = __Dead;
            return true;
        }
        return (__Null) == (from);
    case __Dead:
        NS_RUNTIMEABORT("__delete__()d actor");
        return false;
    default:
        NS_RUNTIMEABORT("corrupted actor state");
        return false;
    }
    (*(next)) = __Error;
    return false;
}

class Msg_AddLibraryMappings :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::Mapping Mapping;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg_AddLibraryMappings__ID
    };
    Msg_AddLibraryMappings() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PCrashReporter::Msg_AddLibraryMappings")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_AddLibraryMappings(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg___delete__ :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::Mapping Mapping;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg___delete____ID
    };
    Msg___delete__() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PCrashReporter::Msg___delete__")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg___delete__(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply___delete__ :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::Mapping Mapping;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Reply___delete____ID
    };
    Reply___delete__() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PCrashReporter::Reply___delete__")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply___delete__(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};



} // namespace PCrashReporter
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct Mapping|
//
namespace mozilla {
namespace dom {
inline Mapping::Mapping()
{
    Init();
}

inline Mapping::~Mapping()
{
}

inline bool
Mapping::operator==(const Mapping& _o) const
{
    if ((!((library_name()) == ((_o).library_name())))) {
        return false;
    }
    if ((!((file_id()) == ((_o).file_id())))) {
        return false;
    }
    if ((!((start_address()) == ((_o).start_address())))) {
        return false;
    }
    if ((!((mapping_length()) == ((_o).mapping_length())))) {
        return false;
    }
    if ((!((file_offset()) == ((_o).file_offset())))) {
        return false;
    }
    return true;
}

inline void
Mapping::Init()
{
}

inline void
Mapping::Assign(
        const nsCString& _library_name,
        const nsCString& _file_id,
        const uintptr_t& _start_address,
        const size_t& _mapping_length,
        const size_t& _file_offset)
{
    library_name_ = _library_name;
    file_id_ = _file_id;
    start_address_ = _start_address;
    mapping_length_ = _mapping_length;
    file_offset_ = _file_offset;
}

} // namespace dom
} // namespace mozilla

#endif // ifndef PCrashReporter_h
