//
// Automatically generated by the IPDL compiler.
// Edit at your own risk
//

#ifndef PMemoryReportRequest_h
#define PMemoryReportRequest_h

#include "base/basictypes.h"
#include "prtime.h"
#include "nscore.h"
#include "IPCMessageStart.h"
#include "IPC/IPCMessageUtils.h"
#include "nsAutoPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "nsIFile.h"
#include "mozilla/ipc/ProtocolUtils.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct MemoryReport|
//
namespace mozilla {
namespace dom {
class NS_FINAL_CLASS MemoryReport
{
private:

public:
    MemoryReport();

    MemoryReport(
            const nsCString& _prefix,
            const nsCString& _path,
            const nsCString& _desc,
            const PRInt64& _memoryUsed)
    {
        Init();
        Assign(_prefix, _path, _desc, _memoryUsed);
    }

    MemoryReport(const MemoryReport& _o)
    {
        Init();
        Assign((_o).prefix(), (_o).path(), (_o).desc(), (_o).memoryUsed());
    }

    ~MemoryReport();

    void
    operator=(const MemoryReport& _o)
    {
        Assign((_o).prefix(), (_o).path(), (_o).desc(), (_o).memoryUsed());
    }

    bool
    operator==(const MemoryReport& _o) const;

    nsCString&
    prefix()
    {
        return prefix_;
    }
    const nsCString&
    prefix() const
    {
        return prefix_;
    }

    nsCString&
    path()
    {
        return path_;
    }
    const nsCString&
    path() const
    {
        return path_;
    }

    nsCString&
    desc()
    {
        return desc_;
    }
    const nsCString&
    desc() const
    {
        return desc_;
    }

    PRInt64&
    memoryUsed()
    {
        return memoryUsed_;
    }
    const PRInt64&
    memoryUsed() const
    {
        return memoryUsed_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsCString& _prefix,
            const nsCString& _path,
            const nsCString& _desc,
            const PRInt64& _memoryUsed);

    nsCString prefix_;
    nsCString path_;
    nsCString desc_;
    PRInt64 memoryUsed_;
};
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PMemoryReportRequestChild and PMemoryReportRequestParent
//
namespace mozilla {
namespace dom {
namespace PMemoryReportRequest {

enum State {
    __Dead,
    __Null,
    __Error,
    __Start = __Null
};

enum MessageType {
    PMemoryReportRequestStart = PMemoryReportRequestMsgStart << 16,
    PMemoryReportRequestPreStart = (PMemoryReportRequestMsgStart << 16) - 1,
    Msg___delete____ID,
    Reply___delete____ID,
    PMemoryReportRequestEnd
};

inline bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next)
{
    switch (from) {
    case __Null:
    case __Error:
        if ((Msg___delete____ID) == ((trigger).mMsg)) {
            (*(next)) = __Dead;
            return true;
        }
        return (__Null) == (from);
    case __Dead:
        NS_RUNTIMEABORT("__delete__()d actor");
        return false;
    default:
        NS_RUNTIMEABORT("corrupted actor state");
        return false;
    }
    (*(next)) = __Error;
    return false;
}

class Msg___delete__ :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::MemoryReport MemoryReport;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Msg___delete____ID
    };
    Msg___delete__() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PMemoryReportRequest::Msg___delete__")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg___delete__(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply___delete__ :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::MemoryReport MemoryReport;
    typedef mozilla::ipc::Shmem Shmem;

public:
    enum {
        ID = Reply___delete____ID
    };
    Reply___delete__() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PMemoryReportRequest::Reply___delete__")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply___delete__(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};



} // namespace PMemoryReportRequest
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct MemoryReport|
//
namespace mozilla {
namespace dom {
inline MemoryReport::MemoryReport()
{
    Init();
}

inline MemoryReport::~MemoryReport()
{
}

inline bool
MemoryReport::operator==(const MemoryReport& _o) const
{
    if ((!((prefix()) == ((_o).prefix())))) {
        return false;
    }
    if ((!((path()) == ((_o).path())))) {
        return false;
    }
    if ((!((desc()) == ((_o).desc())))) {
        return false;
    }
    if ((!((memoryUsed()) == ((_o).memoryUsed())))) {
        return false;
    }
    return true;
}

inline void
MemoryReport::Init()
{
}

inline void
MemoryReport::Assign(
        const nsCString& _prefix,
        const nsCString& _path,
        const nsCString& _desc,
        const PRInt64& _memoryUsed)
{
    prefix_ = _prefix;
    path_ = _path;
    desc_ = _desc;
    memoryUsed_ = _memoryUsed;
}

} // namespace dom
} // namespace mozilla

#endif // ifndef PMemoryReportRequest_h
