//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PStorageChild_h
#define PStorageChild_h

#include "mozilla/dom/PStorage.h"
namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/RPCChannel.h"


namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {


class /*NS_ABSTRACT_CLASS*/ PStorageChild :
    protected mozilla::ipc::RPCChannel::RPCListener,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::RPCChannel::RPCListener>
{
    friend class mozilla::dom::PContentChild;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::ItemData ItemData;
    typedef mozilla::dom::StorageItem StorageItem;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::null_t null_t;
    typedef mozilla::dom::PContentChild PContentChild;

    typedef PStorage::State State;


    virtual void
    ActorDestroy(ActorDestroyReason why);

public:
    typedef IPC::Message Message;
    typedef mozilla::ipc::RPCChannel Channel;
    typedef mozilla::ipc::RPCChannel::RPCListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;

public:
    PStorageChild();

    virtual ~PStorageChild();

    PContentChild*
    Manager();

    PStorage::State
    state();

    static bool
    Send__delete__(PStorageChild* actor);

    bool
    SendInit(
            const bool& useDB,
            const bool& canUseChromePersist,
            const bool& sessionOnly,
            const nsCString& domain,
            const nsCString& scopeDBKey,
            const nsCString& quotaDomainDBKey,
            const nsCString& quotaETLDplus1DomainDBKey,
            const PRUint32& storageType);

    bool
    SendGetKeys(
            const bool& callerSecure,
            InfallibleTArray<nsString>* keys);

    bool
    SendGetLength(
            const bool& callerSecure,
            const bool& sessionOnly,
            PRUint32* length,
            nsresult* rv);

    bool
    SendGetKey(
            const bool& callerSecure,
            const bool& sessionOnly,
            const PRUint32& index,
            nsString* key,
            nsresult* rv);

    bool
    SendGetValue(
            const bool& callerSecure,
            const bool& sessionOnly,
            const nsString& key,
            StorageItem* item,
            nsresult* rv);

    bool
    SendSetValue(
            const bool& callerSecure,
            const bool& sessionOnly,
            const nsString& key,
            const nsString& data,
            nsString* oldValue,
            nsresult* rv);

    bool
    SendRemoveValue(
            const bool& callerSecure,
            const bool& sessionOnly,
            const nsString& key,
            nsString* oldValue,
            nsresult* rv);

    bool
    SendClear(
            const bool& callerSecure,
            const bool& sessionOnly,
            PRInt32* oldCount,
            nsresult* rv);

    bool
    SendGetDBValue(
            const nsString& key,
            nsString* value,
            PRBool* secure,
            nsresult* rv);

    bool
    SendSetDBValue(
            const nsString& key,
            const nsString& value,
            const PRBool& secure,
            nsresult* rv);

    bool
    SendSetSecure(
            const nsString& key,
            const PRBool& secure,
            nsresult* rv);

    virtual Result
    OnMessageReceived(const Message& __msg);

    virtual Result
    OnMessageReceived(
            const Message& __msg,
            Message*& __reply);

    virtual Result
    OnCallReceived(
            const Message& __msg,
            Message*& __reply);

    void
    OnProcessingError(Result code);

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32 pid);

    virtual int32
    Register(ChannelListener* aRouted);
    virtual int32
    RegisterID(
            ChannelListener* aRouted,
            int32 aId);
    virtual ChannelListener*
    Lookup(int32 aId);
    virtual void
    Unregister(int32 aId);
    virtual void
    RemoveManagee(
            int32 aProtocolId,
            ChannelListener* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType type,
            bool unsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& aShmem);
    virtual ProcessHandle
    OtherProcess() const;

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    virtual void
    FatalError(const char* const msg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& __v,
            Message* __msg)
    {
        IPC::WriteParam(__msg, __v);
    }

    template<typename T>
    bool
    Read(
            T* __v,
            const Message* __msg,
            void** __iter)
    {
        return IPC::ReadParam(__msg, __iter, __v);
    }

    void
    Write(
            const ItemData& __v,
            Message* __msg);

    bool
    Read(
            ItemData* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            PStorageChild* __v,
            Message* __msg,
            bool __nullable);

    bool
    Read(
            PStorageChild** __v,
            const Message* __msg,
            void** __iter,
            bool __nullable) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const StorageItem& __v,
            Message* __msg);

    bool
    Read(
            StorageItem* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    Channel* mChannel;
    int32 mId;
    mozilla::ipc::IProtocolManager<mozilla::ipc::RPCChannel::RPCListener>* mManager;
    State mState;
};


} // namespace dom
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace dom {
class StorageChild :
    public PStorageChild
{
    StorageChild();
    virtual ~StorageChild();
};
} // namespace dom
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace dom {
StorageChild::StorageChild()
{
    MOZ_COUNT_CTOR(StorageChild);
}

StorageChild::~StorageChild()
{
    MOZ_COUNT_DTOR(StorageChild);
}

} // namespace dom
} // namespace mozilla
#endif // if 0

#endif // ifndef PStorageChild_h
