//
// Automatically generated by the IPDL compiler.
// Edit at your own risk
//

#ifndef PHttpChannel_h
#define PHttpChannel_h

#include "base/basictypes.h"
#include "prtime.h"
#include "nscore.h"
#include "IPCMessageStart.h"
#include "IPC/IPCMessageUtils.h"
#include "nsAutoPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "nsIFile.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/net/PHttpChannelParams.h"
#include "mozilla/net/NeckoMessageUtils.h"

//-----------------------------------------------------------------------------
// Code common to PHttpChannelChild and PHttpChannelParent
//
namespace mozilla {
namespace net {
namespace PHttpChannel {

enum State {
    __Dead,
    __Null,
    __Error,
    __Start = __Null
};

enum MessageType {
    PHttpChannelStart = PHttpChannelMsgStart << 16,
    PHttpChannelPreStart = (PHttpChannelMsgStart << 16) - 1,
    Msg_AsyncOpen__ID,
    Msg_ConnectChannel__ID,
    Msg_SetPriority__ID,
    Msg_SetCacheTokenCachedCharset__ID,
    Msg_UpdateAssociatedContentSecurity__ID,
    Msg_Suspend__ID,
    Msg_Resume__ID,
    Msg_Cancel__ID,
    Msg_Redirect2Verify__ID,
    Msg_DocumentChannelCleanup__ID,
    Msg_MarkOfflineCacheEntryAsForeign__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_OnStartRequest__ID,
    Msg_OnTransportAndData__ID,
    Msg_OnStopRequest__ID,
    Msg_OnProgress__ID,
    Msg_OnStatus__ID,
    Msg_CancelEarly__ID,
    Msg_Redirect1Begin__ID,
    Msg_Redirect3Complete__ID,
    Msg_AssociateApplicationCache__ID,
    Msg_DeleteSelf__ID,
    PHttpChannelEnd
};

inline bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next)
{
    switch (from) {
    case __Null:
    case __Error:
        if ((Msg___delete____ID) == ((trigger).mMsg)) {
            (*(next)) = __Dead;
            return true;
        }
        return (__Null) == (from);
    case __Dead:
        NS_RUNTIMEABORT("__delete__()d actor");
        return false;
    default:
        NS_RUNTIMEABORT("corrupted actor state");
        return false;
    }
    (*(next)) = __Error;
    return false;
}

class Msg_AsyncOpen :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef IPC::URI URI;
    typedef IPC::InputStream InputStream;

public:
    enum {
        ID = Msg_AsyncOpen__ID
    };
    Msg_AsyncOpen() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHttpChannel::Msg_AsyncOpen")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_AsyncOpen(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_ConnectChannel :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef IPC::URI URI;
    typedef IPC::InputStream InputStream;

public:
    enum {
        ID = Msg_ConnectChannel__ID
    };
    Msg_ConnectChannel() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHttpChannel::Msg_ConnectChannel")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_ConnectChannel(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_SetPriority :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef IPC::URI URI;
    typedef IPC::InputStream InputStream;

public:
    enum {
        ID = Msg_SetPriority__ID
    };
    Msg_SetPriority() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHttpChannel::Msg_SetPriority")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_SetPriority(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_SetCacheTokenCachedCharset :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef IPC::URI URI;
    typedef IPC::InputStream InputStream;

public:
    enum {
        ID = Msg_SetCacheTokenCachedCharset__ID
    };
    Msg_SetCacheTokenCachedCharset() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHttpChannel::Msg_SetCacheTokenCachedCharset")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_SetCacheTokenCachedCharset(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_UpdateAssociatedContentSecurity :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef IPC::URI URI;
    typedef IPC::InputStream InputStream;

public:
    enum {
        ID = Msg_UpdateAssociatedContentSecurity__ID
    };
    Msg_UpdateAssociatedContentSecurity() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHttpChannel::Msg_UpdateAssociatedContentSecurity")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_UpdateAssociatedContentSecurity(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_Suspend :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef IPC::URI URI;
    typedef IPC::InputStream InputStream;

public:
    enum {
        ID = Msg_Suspend__ID
    };
    Msg_Suspend() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHttpChannel::Msg_Suspend")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_Suspend(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_Resume :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef IPC::URI URI;
    typedef IPC::InputStream InputStream;

public:
    enum {
        ID = Msg_Resume__ID
    };
    Msg_Resume() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHttpChannel::Msg_Resume")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_Resume(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_Cancel :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef IPC::URI URI;
    typedef IPC::InputStream InputStream;

public:
    enum {
        ID = Msg_Cancel__ID
    };
    Msg_Cancel() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHttpChannel::Msg_Cancel")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_Cancel(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_Redirect2Verify :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef IPC::URI URI;
    typedef IPC::InputStream InputStream;

public:
    enum {
        ID = Msg_Redirect2Verify__ID
    };
    Msg_Redirect2Verify() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHttpChannel::Msg_Redirect2Verify")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_Redirect2Verify(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_DocumentChannelCleanup :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef IPC::URI URI;
    typedef IPC::InputStream InputStream;

public:
    enum {
        ID = Msg_DocumentChannelCleanup__ID
    };
    Msg_DocumentChannelCleanup() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHttpChannel::Msg_DocumentChannelCleanup")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_DocumentChannelCleanup(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_MarkOfflineCacheEntryAsForeign :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef IPC::URI URI;
    typedef IPC::InputStream InputStream;

public:
    enum {
        ID = Msg_MarkOfflineCacheEntryAsForeign__ID
    };
    Msg_MarkOfflineCacheEntryAsForeign() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHttpChannel::Msg_MarkOfflineCacheEntryAsForeign")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_MarkOfflineCacheEntryAsForeign(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg___delete__ :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef IPC::URI URI;
    typedef IPC::InputStream InputStream;

public:
    enum {
        ID = Msg___delete____ID
    };
    Msg___delete__() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHttpChannel::Msg___delete__")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg___delete__(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply___delete__ :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef IPC::URI URI;
    typedef IPC::InputStream InputStream;

public:
    enum {
        ID = Reply___delete____ID
    };
    Reply___delete__() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHttpChannel::Reply___delete__")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply___delete__(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_OnStartRequest :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef IPC::URI URI;
    typedef IPC::InputStream InputStream;

public:
    enum {
        ID = Msg_OnStartRequest__ID
    };
    Msg_OnStartRequest() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHttpChannel::Msg_OnStartRequest")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_OnStartRequest(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_OnTransportAndData :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef IPC::URI URI;
    typedef IPC::InputStream InputStream;

public:
    enum {
        ID = Msg_OnTransportAndData__ID
    };
    Msg_OnTransportAndData() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHttpChannel::Msg_OnTransportAndData")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_OnTransportAndData(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_OnStopRequest :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef IPC::URI URI;
    typedef IPC::InputStream InputStream;

public:
    enum {
        ID = Msg_OnStopRequest__ID
    };
    Msg_OnStopRequest() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHttpChannel::Msg_OnStopRequest")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_OnStopRequest(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_OnProgress :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef IPC::URI URI;
    typedef IPC::InputStream InputStream;

public:
    enum {
        ID = Msg_OnProgress__ID
    };
    Msg_OnProgress() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHttpChannel::Msg_OnProgress")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_OnProgress(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_OnStatus :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef IPC::URI URI;
    typedef IPC::InputStream InputStream;

public:
    enum {
        ID = Msg_OnStatus__ID
    };
    Msg_OnStatus() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHttpChannel::Msg_OnStatus")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_OnStatus(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_CancelEarly :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef IPC::URI URI;
    typedef IPC::InputStream InputStream;

public:
    enum {
        ID = Msg_CancelEarly__ID
    };
    Msg_CancelEarly() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHttpChannel::Msg_CancelEarly")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_CancelEarly(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_Redirect1Begin :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef IPC::URI URI;
    typedef IPC::InputStream InputStream;

public:
    enum {
        ID = Msg_Redirect1Begin__ID
    };
    Msg_Redirect1Begin() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHttpChannel::Msg_Redirect1Begin")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_Redirect1Begin(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_Redirect3Complete :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef IPC::URI URI;
    typedef IPC::InputStream InputStream;

public:
    enum {
        ID = Msg_Redirect3Complete__ID
    };
    Msg_Redirect3Complete() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHttpChannel::Msg_Redirect3Complete")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_Redirect3Complete(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_AssociateApplicationCache :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef IPC::URI URI;
    typedef IPC::InputStream InputStream;

public:
    enum {
        ID = Msg_AssociateApplicationCache__ID
    };
    Msg_AssociateApplicationCache() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHttpChannel::Msg_AssociateApplicationCache")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_AssociateApplicationCache(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_DeleteSelf :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef IPC::URI URI;
    typedef IPC::InputStream InputStream;

public:
    enum {
        ID = Msg_DeleteSelf__ID
    };
    Msg_DeleteSelf() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PHttpChannel::Msg_DeleteSelf")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_DeleteSelf(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};



} // namespace PHttpChannel
} // namespace net
} // namespace mozilla

#endif // ifndef PHttpChannel_h
