//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PHttpChannelParent_h
#define PHttpChannelParent_h

#include "mozilla/net/PHttpChannel.h"
namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla

#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/RPCChannel.h"


namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {


class /*NS_ABSTRACT_CLASS*/ PHttpChannelParent :
    protected mozilla::ipc::RPCChannel::RPCListener,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::RPCChannel::RPCListener>
{
    friend class mozilla::net::PNeckoParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef IPC::URI URI;
    typedef IPC::InputStream InputStream;
    typedef mozilla::net::PNeckoParent PNeckoParent;

    typedef PHttpChannel::State State;

    virtual bool
    RecvAsyncOpen(
            const URI& uri,
            const URI& original,
            const URI& doc,
            const URI& referrer,
            const PRUint32& loadFlags,
            const RequestHeaderTuples& requestHeaders,
            const nsHttpAtom& requestMethod,
            const InputStream& uploadStream,
            const PRBool& uploadStreamHasHeaders,
            const PRUint16& priority,
            const PRUint8& redirectionLimit,
            const PRBool& allowPipelining,
            const PRBool& forceAllowThirdPartyCookie,
            const bool& resumeAt,
            const PRUint64& startPos,
            const nsCString& entityID,
            const bool& chooseApplicationCache,
            const nsCString& appCacheClientID) = 0;
    virtual bool
    RecvConnectChannel(const PRUint32& channelId) = 0;
    virtual bool
    RecvSetPriority(const PRUint16& priority) = 0;
    virtual bool
    RecvSetCacheTokenCachedCharset(const nsCString& charset) = 0;
    virtual bool
    RecvUpdateAssociatedContentSecurity(
            const PRInt32& high,
            const PRInt32& low,
            const PRInt32& broken,
            const PRInt32& no) = 0;
    virtual bool
    RecvSuspend() = 0;
    virtual bool
    RecvResume() = 0;
    virtual bool
    RecvCancel(const nsresult& status) = 0;
    virtual bool
    RecvRedirect2Verify(
            const nsresult& result,
            const RequestHeaderTuples& changedHeaders) = 0;
    virtual bool
    RecvDocumentChannelCleanup() = 0;
    virtual bool
    RecvMarkOfflineCacheEntryAsForeign() = 0;
    virtual bool
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason why);

public:
    typedef IPC::Message Message;
    typedef mozilla::ipc::RPCChannel Channel;
    typedef mozilla::ipc::RPCChannel::RPCListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;

public:
    PHttpChannelParent();

    virtual ~PHttpChannelParent();

    PNeckoParent*
    Manager();

    PHttpChannel::State
    state();

    bool
    SendOnStartRequest(
            const nsHttpResponseHead& responseHead,
            const PRBool& useResponseHead,
            const RequestHeaderTuples& requestHeaders,
            const PRBool& isFromCache,
            const PRBool& cacheEntryAvailable,
            const PRUint32& cacheExpirationTime,
            const nsCString& cachedCharset,
            const nsCString& securityInfoSerialization) NS_WARN_UNUSED_RESULT;

    bool
    SendOnTransportAndData(
            const nsresult& status,
            const PRUint64& progress,
            const PRUint64& progressMax,
            const nsCString& data,
            const PRUint32& offset,
            const PRUint32& count) NS_WARN_UNUSED_RESULT;

    bool
    SendOnStopRequest(const nsresult& statusCode) NS_WARN_UNUSED_RESULT;

    bool
    SendOnProgress(
            const PRUint64& progress,
            const PRUint64& progressMax) NS_WARN_UNUSED_RESULT;

    bool
    SendOnStatus(const nsresult& status) NS_WARN_UNUSED_RESULT;

    bool
    SendCancelEarly(const nsresult& status) NS_WARN_UNUSED_RESULT;

    bool
    SendRedirect1Begin(
            const PRUint32& newChannelId,
            const URI& newUri,
            const PRUint32& redirectFlags,
            const nsHttpResponseHead& responseHead) NS_WARN_UNUSED_RESULT;

    bool
    SendRedirect3Complete() NS_WARN_UNUSED_RESULT;

    bool
    SendAssociateApplicationCache(
            const nsCString& groupID,
            const nsCString& clientID) NS_WARN_UNUSED_RESULT;

    bool
    SendDeleteSelf() NS_WARN_UNUSED_RESULT;

    virtual Result
    OnMessageReceived(const Message& __msg);

    virtual Result
    OnMessageReceived(
            const Message& __msg,
            Message*& __reply);

    virtual Result
    OnCallReceived(
            const Message& __msg,
            Message*& __reply);

    void
    OnProcessingError(Result code);

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32 pid);

    virtual int32
    Register(ChannelListener* aRouted);
    virtual int32
    RegisterID(
            ChannelListener* aRouted,
            int32 aId);
    virtual ChannelListener*
    Lookup(int32 aId);
    virtual void
    Unregister(int32 aId);
    virtual void
    RemoveManagee(
            int32 aProtocolId,
            ChannelListener* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType type,
            bool unsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& aShmem);
    virtual ProcessHandle
    OtherProcess() const;

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    virtual void
    FatalError(const char* const msg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& __v,
            Message* __msg)
    {
        IPC::WriteParam(__msg, __v);
    }

    template<typename T>
    bool
    Read(
            T* __v,
            const Message* __msg,
            void** __iter)
    {
        return IPC::ReadParam(__msg, __iter, __v);
    }

    void
    Write(
            PHttpChannelParent* __v,
            Message* __msg,
            bool __nullable);

    bool
    Read(
            PHttpChannelParent** __v,
            const Message* __msg,
            void** __iter,
            bool __nullable) NS_WARN_UNUSED_RESULT;

    Channel* mChannel;
    int32 mId;
    mozilla::ipc::IProtocolManager<mozilla::ipc::RPCChannel::RPCListener>* mManager;
    State mState;
};


} // namespace net
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace net {
class HttpChannelParent :
    public PHttpChannelParent
{
    virtual bool
    RecvAsyncOpen(
            const URI& uri,
            const URI& original,
            const URI& doc,
            const URI& referrer,
            const PRUint32& loadFlags,
            const RequestHeaderTuples& requestHeaders,
            const nsHttpAtom& requestMethod,
            const InputStream& uploadStream,
            const PRBool& uploadStreamHasHeaders,
            const PRUint16& priority,
            const PRUint8& redirectionLimit,
            const PRBool& allowPipelining,
            const PRBool& forceAllowThirdPartyCookie,
            const bool& resumeAt,
            const PRUint64& startPos,
            const nsCString& entityID,
            const bool& chooseApplicationCache,
            const nsCString& appCacheClientID);

    virtual bool
    RecvConnectChannel(const PRUint32& channelId);

    virtual bool
    RecvSetPriority(const PRUint16& priority);

    virtual bool
    RecvSetCacheTokenCachedCharset(const nsCString& charset);

    virtual bool
    RecvUpdateAssociatedContentSecurity(
            const PRInt32& high,
            const PRInt32& low,
            const PRInt32& broken,
            const PRInt32& no);

    virtual bool
    RecvSuspend();

    virtual bool
    RecvResume();

    virtual bool
    RecvCancel(const nsresult& status);

    virtual bool
    RecvRedirect2Verify(
            const nsresult& result,
            const RequestHeaderTuples& changedHeaders);

    virtual bool
    RecvDocumentChannelCleanup();

    virtual bool
    RecvMarkOfflineCacheEntryAsForeign();

    HttpChannelParent();
    virtual ~HttpChannelParent();
};
} // namespace net
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace net {
bool
HttpChannelParent::RecvAsyncOpen(
        const URI& uri,
        const URI& original,
        const URI& doc,
        const URI& referrer,
        const PRUint32& loadFlags,
        const RequestHeaderTuples& requestHeaders,
        const nsHttpAtom& requestMethod,
        const InputStream& uploadStream,
        const PRBool& uploadStreamHasHeaders,
        const PRUint16& priority,
        const PRUint8& redirectionLimit,
        const PRBool& allowPipelining,
        const PRBool& forceAllowThirdPartyCookie,
        const bool& resumeAt,
        const PRUint64& startPos,
        const nsCString& entityID,
        const bool& chooseApplicationCache,
        const nsCString& appCacheClientID)
{
    return false;
}

bool
HttpChannelParent::RecvConnectChannel(const PRUint32& channelId)
{
    return false;
}

bool
HttpChannelParent::RecvSetPriority(const PRUint16& priority)
{
    return false;
}

bool
HttpChannelParent::RecvSetCacheTokenCachedCharset(const nsCString& charset)
{
    return false;
}

bool
HttpChannelParent::RecvUpdateAssociatedContentSecurity(
        const PRInt32& high,
        const PRInt32& low,
        const PRInt32& broken,
        const PRInt32& no)
{
    return false;
}

bool
HttpChannelParent::RecvSuspend()
{
    return false;
}

bool
HttpChannelParent::RecvResume()
{
    return false;
}

bool
HttpChannelParent::RecvCancel(const nsresult& status)
{
    return false;
}

bool
HttpChannelParent::RecvRedirect2Verify(
        const nsresult& result,
        const RequestHeaderTuples& changedHeaders)
{
    return false;
}

bool
HttpChannelParent::RecvDocumentChannelCleanup()
{
    return false;
}

bool
HttpChannelParent::RecvMarkOfflineCacheEntryAsForeign()
{
    return false;
}

HttpChannelParent::HttpChannelParent()
{
    MOZ_COUNT_CTOR(HttpChannelParent);
}

HttpChannelParent::~HttpChannelParent()
{
    MOZ_COUNT_DTOR(HttpChannelParent);
}

} // namespace net
} // namespace mozilla
#endif // if 0

#endif // ifndef PHttpChannelParent_h
