//
// Automatically generated by the IPDL compiler.
// Edit at your own risk
//

#ifndef PPluginInstance_h
#define PPluginInstance_h

#include "base/basictypes.h"
#include "prtime.h"
#include "nscore.h"
#include "IPCMessageStart.h"
#include "IPC/IPCMessageUtils.h"
#include "nsAutoPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "nsIFile.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/plugins/PluginMessageUtils.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SurfaceDescriptorX11|
//
namespace mozilla {
namespace plugins {
class NS_FINAL_CLASS SurfaceDescriptorX11
{
private:

public:
    SurfaceDescriptorX11();

    SurfaceDescriptorX11(
            const int& _XID,
            const int& _xrenderPictID,
            const gfxIntSize& _size)
    {
        Init();
        Assign(_XID, _xrenderPictID, _size);
    }

    SurfaceDescriptorX11(const SurfaceDescriptorX11& _o)
    {
        Init();
        Assign((_o).XID(), (_o).xrenderPictID(), (_o).size());
    }

    ~SurfaceDescriptorX11();

    void
    operator=(const SurfaceDescriptorX11& _o)
    {
        Assign((_o).XID(), (_o).xrenderPictID(), (_o).size());
    }

    bool
    operator==(const SurfaceDescriptorX11& _o) const;

    int&
    XID()
    {
        return XID_;
    }
    const int&
    XID() const
    {
        return XID_;
    }

    int&
    xrenderPictID()
    {
        return xrenderPictID_;
    }
    const int&
    xrenderPictID() const
    {
        return xrenderPictID_;
    }

    gfxIntSize&
    size()
    {
        return size_;
    }
    const gfxIntSize&
    size() const
    {
        return size_;
    }

private:
    void
    Init();

    void
    Assign(
            const int& _XID,
            const int& _xrenderPictID,
            const gfxIntSize& _size);

    int XID_;
    int xrenderPictID_;
    gfxIntSize size_;
};
} // namespace plugins
} // namespace mozilla

namespace mozilla {
namespace plugins {
class SurfaceDescriptorX11;
} // namespace plugins
} // namespace mozilla
namespace mozilla {
namespace plugins {
class PPluginSurfaceParent;
} // namespace plugins
} // namespace mozilla

namespace mozilla {
namespace plugins {
class PPluginSurfaceChild;
} // namespace plugins
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union SurfaceDescriptor|
//
namespace mozilla {
namespace plugins {
class NS_FINAL_CLASS SurfaceDescriptor
{
public:
    enum Type {
        T__None,
        TShmem = 1,
        TSurfaceDescriptorX11,
        TPPluginSurfaceParent,
        TPPluginSurfaceChild,
        Tnull_t,
        T__Last = Tnull_t
    };

private:
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::PPluginSurfaceParent PPluginSurfaceParent;
    typedef mozilla::plugins::PPluginSurfaceChild PPluginSurfaceChild;
    typedef mozilla::null_t null_t;
    typedef Shmem Shmem__tdef;
    typedef SurfaceDescriptorX11 SurfaceDescriptorX11__tdef;
    typedef PPluginSurfaceParent* PPluginSurfaceParent__tdef;
    typedef PPluginSurfaceChild* PPluginSurfaceChild__tdef;
    typedef null_t null_t__tdef;

    union Value {
        char VShmem[sizeof(Shmem)];
        char VSurfaceDescriptorX11[sizeof(SurfaceDescriptorX11)];
        char VPPluginSurfaceParent[sizeof(PPluginSurfaceParent*)];
        char VPPluginSurfaceChild[sizeof(PPluginSurfaceChild*)];
        char Vnull_t[sizeof(null_t)];
    };

    Shmem*
    ptr_Shmem()
    {
        return reinterpret_cast<Shmem*>((&((mValue).VShmem)));
    }
    const Shmem* const
    constptr_Shmem() const
    {
        return reinterpret_cast<const Shmem* const>((&((mValue).VShmem)));
    }
    SurfaceDescriptorX11*
    ptr_SurfaceDescriptorX11()
    {
        return reinterpret_cast<SurfaceDescriptorX11*>((&((mValue).VSurfaceDescriptorX11)));
    }
    const SurfaceDescriptorX11* const
    constptr_SurfaceDescriptorX11() const
    {
        return reinterpret_cast<const SurfaceDescriptorX11* const>((&((mValue).VSurfaceDescriptorX11)));
    }
    PPluginSurfaceParent**
    ptr_PPluginSurfaceParent()
    {
        return reinterpret_cast<PPluginSurfaceParent**>((&((mValue).VPPluginSurfaceParent)));
    }
    PPluginSurfaceParent* const*
    constptr_PPluginSurfaceParent() const
    {
        return reinterpret_cast<PPluginSurfaceParent* const*>((&((mValue).VPPluginSurfaceParent)));
    }
    PPluginSurfaceChild**
    ptr_PPluginSurfaceChild()
    {
        return reinterpret_cast<PPluginSurfaceChild**>((&((mValue).VPPluginSurfaceChild)));
    }
    PPluginSurfaceChild* const*
    constptr_PPluginSurfaceChild() const
    {
        return reinterpret_cast<PPluginSurfaceChild* const*>((&((mValue).VPPluginSurfaceChild)));
    }
    null_t*
    ptr_null_t()
    {
        return reinterpret_cast<null_t*>((&((mValue).Vnull_t)));
    }
    const null_t* const
    constptr_null_t() const
    {
        return reinterpret_cast<const null_t* const>((&((mValue).Vnull_t)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        NS_ABORT_IF_FALSE((T__None) <= (mType), "invalid type tag");
        NS_ABORT_IF_FALSE((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        NS_ABORT_IF_FALSE((mType) == (aType), "unexpected type tag");
    }

public:
    SurfaceDescriptor() :
        mType(T__None)
    {
    }

    SurfaceDescriptor(Shmem& aOther);

    SurfaceDescriptor(const SurfaceDescriptorX11& aOther);

    SurfaceDescriptor(PPluginSurfaceParent* aOther);

    SurfaceDescriptor(PPluginSurfaceChild* aOther);

    SurfaceDescriptor(const null_t& aOther);

    SurfaceDescriptor(const SurfaceDescriptor& aOther);

    ~SurfaceDescriptor();

    Type
    type() const
    {
        return mType;
    }

    SurfaceDescriptor&
    operator=(Shmem& aRhs);

    SurfaceDescriptor&
    operator=(const SurfaceDescriptorX11& aRhs);

    SurfaceDescriptor&
    operator=(PPluginSurfaceParent* aRhs);

    SurfaceDescriptor&
    operator=(PPluginSurfaceChild* aRhs);

    SurfaceDescriptor&
    operator=(const null_t& aRhs);

    SurfaceDescriptor&
    operator=(const SurfaceDescriptor& aRhs);

    bool
    operator==(Shmem& aRhs) const;

    bool
    operator==(const SurfaceDescriptorX11& aRhs) const;

    bool
    operator==(PPluginSurfaceParent* aRhs) const;

    bool
    operator==(PPluginSurfaceChild* aRhs) const;

    bool
    operator==(const null_t& aRhs) const;

    bool
    operator==(const SurfaceDescriptor& aRhs) const;

    Shmem&
    get_Shmem()
    {
        AssertSanity(TShmem);
        return (*(ptr_Shmem()));
    }
    Shmem&
    get_Shmem() const
    {
        AssertSanity(TShmem);
        return const_cast<Shmem&>((*(constptr_Shmem())));
    }
    operator Shmem&()
    {
        return get_Shmem();
    }
    operator Shmem&() const
    {
        return get_Shmem();
    }

    SurfaceDescriptorX11&
    get_SurfaceDescriptorX11()
    {
        AssertSanity(TSurfaceDescriptorX11);
        return (*(ptr_SurfaceDescriptorX11()));
    }
    const SurfaceDescriptorX11&
    get_SurfaceDescriptorX11() const
    {
        AssertSanity(TSurfaceDescriptorX11);
        return (*(constptr_SurfaceDescriptorX11()));
    }
    operator SurfaceDescriptorX11&()
    {
        return get_SurfaceDescriptorX11();
    }
    operator const SurfaceDescriptorX11&() const
    {
        return get_SurfaceDescriptorX11();
    }

    PPluginSurfaceParent*&
    get_PPluginSurfaceParent()
    {
        AssertSanity(TPPluginSurfaceParent);
        return (*(ptr_PPluginSurfaceParent()));
    }
    PPluginSurfaceParent*
    get_PPluginSurfaceParent() const
    {
        AssertSanity(TPPluginSurfaceParent);
        return (*(constptr_PPluginSurfaceParent()));
    }
    operator PPluginSurfaceParent*&()
    {
        return get_PPluginSurfaceParent();
    }
    operator PPluginSurfaceParent*() const
    {
        return get_PPluginSurfaceParent();
    }

    PPluginSurfaceChild*&
    get_PPluginSurfaceChild()
    {
        AssertSanity(TPPluginSurfaceChild);
        return (*(ptr_PPluginSurfaceChild()));
    }
    PPluginSurfaceChild*
    get_PPluginSurfaceChild() const
    {
        AssertSanity(TPPluginSurfaceChild);
        return (*(constptr_PPluginSurfaceChild()));
    }
    operator PPluginSurfaceChild*&()
    {
        return get_PPluginSurfaceChild();
    }
    operator PPluginSurfaceChild*() const
    {
        return get_PPluginSurfaceChild();
    }

    null_t&
    get_null_t()
    {
        AssertSanity(Tnull_t);
        return (*(ptr_null_t()));
    }
    const null_t&
    get_null_t() const
    {
        AssertSanity(Tnull_t);
        return (*(constptr_null_t()));
    }
    operator null_t&()
    {
        return get_null_t();
    }
    operator const null_t&() const
    {
        return get_null_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace plugins
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PPluginInstanceChild and PPluginInstanceParent
//
namespace mozilla {
namespace plugins {
namespace PPluginInstance {

enum State {
    __Dead,
    __Null,
    __Error,
    __Start = __Null
};

enum MessageType {
    PPluginInstanceStart = PPluginInstanceMsgStart << 16,
    PPluginInstancePreStart = (PPluginInstanceMsgStart << 16) - 1,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_NPP_SetWindow__ID,
    Reply_NPP_SetWindow__ID,
    Msg_NPP_GetValue_NPPVpluginNeedsXEmbed__ID,
    Reply_NPP_GetValue_NPPVpluginNeedsXEmbed__ID,
    Msg_NPP_GetValue_NPPVpluginScriptableNPObject__ID,
    Reply_NPP_GetValue_NPPVpluginScriptableNPObject__ID,
    Msg_NPP_SetValue_NPNVprivateModeBool__ID,
    Reply_NPP_SetValue_NPNVprivateModeBool__ID,
    Msg_NPP_HandleEvent__ID,
    Reply_NPP_HandleEvent__ID,
    Msg_NPP_HandleEvent_Shmem__ID,
    Reply_NPP_HandleEvent_Shmem__ID,
    Msg_NPP_HandleEvent_IOSurface__ID,
    Reply_NPP_HandleEvent_IOSurface__ID,
    Msg_Paint__ID,
    Reply_Paint__ID,
    Msg_WindowPosChanged__ID,
    Msg_AsyncSetWindow__ID,
    Msg_UpdateBackground__ID,
    Msg_NPP_Destroy__ID,
    Reply_NPP_Destroy__ID,
    Msg_NPN_GetValue_NPNVjavascriptEnabledBool__ID,
    Reply_NPN_GetValue_NPNVjavascriptEnabledBool__ID,
    Msg_NPN_GetValue_NPNVisOfflineBool__ID,
    Reply_NPN_GetValue_NPNVisOfflineBool__ID,
    Msg_NPN_GetValue_NPNVWindowNPObject__ID,
    Reply_NPN_GetValue_NPNVWindowNPObject__ID,
    Msg_NPN_GetValue_NPNVPluginElementNPObject__ID,
    Reply_NPN_GetValue_NPNVPluginElementNPObject__ID,
    Msg_NPN_GetValue_NPNVprivateModeBool__ID,
    Reply_NPN_GetValue_NPNVprivateModeBool__ID,
    Msg_NPN_GetValue_NPNVnetscapeWindow__ID,
    Reply_NPN_GetValue_NPNVnetscapeWindow__ID,
    Msg_NPN_SetValue_NPPVpluginWindow__ID,
    Reply_NPN_SetValue_NPPVpluginWindow__ID,
    Msg_NPN_SetValue_NPPVpluginTransparent__ID,
    Reply_NPN_SetValue_NPPVpluginTransparent__ID,
    Msg_NPN_SetValue_NPPVpluginUsesDOMForCursor__ID,
    Reply_NPN_SetValue_NPPVpluginUsesDOMForCursor__ID,
    Msg_NPN_SetValue_NPPVpluginDrawingModel__ID,
    Reply_NPN_SetValue_NPPVpluginDrawingModel__ID,
    Msg_NPN_SetValue_NPPVpluginEventModel__ID,
    Reply_NPN_SetValue_NPPVpluginEventModel__ID,
    Msg_NPN_GetURL__ID,
    Reply_NPN_GetURL__ID,
    Msg_NPN_PostURL__ID,
    Reply_NPN_PostURL__ID,
    Msg_PStreamNotifyConstructor__ID,
    Reply_PStreamNotifyConstructor__ID,
    Msg_NPN_InvalidateRect__ID,
    Msg_Show__ID,
    Reply_Show__ID,
    Msg_PPluginSurfaceConstructor__ID,
    Reply_PPluginSurfaceConstructor__ID,
    Msg_NPN_PushPopupsEnabledState__ID,
    Reply_NPN_PushPopupsEnabledState__ID,
    Msg_NPN_PopPopupsEnabledState__ID,
    Reply_NPN_PopPopupsEnabledState__ID,
    Msg_NPN_GetValueForURL__ID,
    Reply_NPN_GetValueForURL__ID,
    Msg_NPN_SetValueForURL__ID,
    Reply_NPN_SetValueForURL__ID,
    Msg_NPN_GetAuthenticationInfo__ID,
    Reply_NPN_GetAuthenticationInfo__ID,
    Msg_NPN_ConvertPoint__ID,
    Reply_NPN_ConvertPoint__ID,
    Msg_NegotiatedCarbon__ID,
    Reply_NegotiatedCarbon__ID,
    Msg_PPluginScriptableObjectConstructor__ID,
    Reply_PPluginScriptableObjectConstructor__ID,
    Msg_PBrowserStreamConstructor__ID,
    Reply_PBrowserStreamConstructor__ID,
    Msg_PPluginStreamConstructor__ID,
    Reply_PPluginStreamConstructor__ID,
    Msg_PluginFocusChange__ID,
    Reply_PluginFocusChange__ID,
    Msg_SetPluginFocus__ID,
    Reply_SetPluginFocus__ID,
    Msg_UpdateWindow__ID,
    Reply_UpdateWindow__ID,
    Msg_PPluginBackgroundDestroyerConstructor__ID,
    Reply_PPluginBackgroundDestroyerConstructor__ID,
    PPluginInstanceEnd
};

inline bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next)
{
    switch (from) {
    case __Null:
    case __Error:
        if ((Msg___delete____ID) == ((trigger).mMsg)) {
            (*(next)) = __Dead;
            return true;
        }
        return (__Null) == (from);
    case __Dead:
        NS_RUNTIMEABORT("__delete__()d actor");
        return false;
    default:
        NS_RUNTIMEABORT("corrupted actor state");
        return false;
    }
    (*(next)) = __Error;
    return false;
}

class Msg___delete__ :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg___delete____ID
    };
    Msg___delete__() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg___delete__")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg___delete__(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply___delete__ :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply___delete____ID
    };
    Reply___delete__() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply___delete__")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply___delete__(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NPP_SetWindow :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_NPP_SetWindow__ID
    };
    Msg_NPP_SetWindow() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_NPP_SetWindow")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPP_SetWindow(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_NPP_SetWindow :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_NPP_SetWindow__ID
    };
    Reply_NPP_SetWindow() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_NPP_SetWindow")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_NPP_SetWindow(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NPP_GetValue_NPPVpluginNeedsXEmbed :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_NPP_GetValue_NPPVpluginNeedsXEmbed__ID
    };
    Msg_NPP_GetValue_NPPVpluginNeedsXEmbed() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_NPP_GetValue_NPPVpluginNeedsXEmbed")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPP_GetValue_NPPVpluginNeedsXEmbed(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_NPP_GetValue_NPPVpluginNeedsXEmbed :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_NPP_GetValue_NPPVpluginNeedsXEmbed__ID
    };
    Reply_NPP_GetValue_NPPVpluginNeedsXEmbed() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_NPP_GetValue_NPPVpluginNeedsXEmbed")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_NPP_GetValue_NPPVpluginNeedsXEmbed(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NPP_GetValue_NPPVpluginScriptableNPObject :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_NPP_GetValue_NPPVpluginScriptableNPObject__ID
    };
    Msg_NPP_GetValue_NPPVpluginScriptableNPObject() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_NPP_GetValue_NPPVpluginScriptableNPObject")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPP_GetValue_NPPVpluginScriptableNPObject(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_NPP_GetValue_NPPVpluginScriptableNPObject :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_NPP_GetValue_NPPVpluginScriptableNPObject__ID
    };
    Reply_NPP_GetValue_NPPVpluginScriptableNPObject() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_NPP_GetValue_NPPVpluginScriptableNPObject")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_NPP_GetValue_NPPVpluginScriptableNPObject(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NPP_SetValue_NPNVprivateModeBool :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_NPP_SetValue_NPNVprivateModeBool__ID
    };
    Msg_NPP_SetValue_NPNVprivateModeBool() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_NPP_SetValue_NPNVprivateModeBool")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPP_SetValue_NPNVprivateModeBool(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_NPP_SetValue_NPNVprivateModeBool :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_NPP_SetValue_NPNVprivateModeBool__ID
    };
    Reply_NPP_SetValue_NPNVprivateModeBool() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_NPP_SetValue_NPNVprivateModeBool")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_NPP_SetValue_NPNVprivateModeBool(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NPP_HandleEvent :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_NPP_HandleEvent__ID
    };
    Msg_NPP_HandleEvent() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_NPP_HandleEvent")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPP_HandleEvent(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_NPP_HandleEvent :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_NPP_HandleEvent__ID
    };
    Reply_NPP_HandleEvent() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_NPP_HandleEvent")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_NPP_HandleEvent(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NPP_HandleEvent_Shmem :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_NPP_HandleEvent_Shmem__ID
    };
    Msg_NPP_HandleEvent_Shmem() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_NPP_HandleEvent_Shmem")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPP_HandleEvent_Shmem(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_NPP_HandleEvent_Shmem :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_NPP_HandleEvent_Shmem__ID
    };
    Reply_NPP_HandleEvent_Shmem() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_NPP_HandleEvent_Shmem")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_NPP_HandleEvent_Shmem(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NPP_HandleEvent_IOSurface :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_NPP_HandleEvent_IOSurface__ID
    };
    Msg_NPP_HandleEvent_IOSurface() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_NPP_HandleEvent_IOSurface")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPP_HandleEvent_IOSurface(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_NPP_HandleEvent_IOSurface :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_NPP_HandleEvent_IOSurface__ID
    };
    Reply_NPP_HandleEvent_IOSurface() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_NPP_HandleEvent_IOSurface")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_NPP_HandleEvent_IOSurface(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_Paint :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_Paint__ID
    };
    Msg_Paint() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_Paint")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_Paint(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_Paint :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_Paint__ID
    };
    Reply_Paint() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_Paint")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_Paint(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_WindowPosChanged :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_WindowPosChanged__ID
    };
    Msg_WindowPosChanged() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_WindowPosChanged")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_WindowPosChanged(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_AsyncSetWindow :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_AsyncSetWindow__ID
    };
    Msg_AsyncSetWindow() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_AsyncSetWindow")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_AsyncSetWindow(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_UpdateBackground :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_UpdateBackground__ID
    };
    Msg_UpdateBackground() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_UpdateBackground")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_UpdateBackground(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NPP_Destroy :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_NPP_Destroy__ID
    };
    Msg_NPP_Destroy() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_NPP_Destroy")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPP_Destroy(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_NPP_Destroy :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_NPP_Destroy__ID
    };
    Reply_NPP_Destroy() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_NPP_Destroy")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_NPP_Destroy(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NPN_GetValue_NPNVjavascriptEnabledBool :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_NPN_GetValue_NPNVjavascriptEnabledBool__ID
    };
    Msg_NPN_GetValue_NPNVjavascriptEnabledBool() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_NPN_GetValue_NPNVjavascriptEnabledBool")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPN_GetValue_NPNVjavascriptEnabledBool(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_NPN_GetValue_NPNVjavascriptEnabledBool :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_NPN_GetValue_NPNVjavascriptEnabledBool__ID
    };
    Reply_NPN_GetValue_NPNVjavascriptEnabledBool() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_NPN_GetValue_NPNVjavascriptEnabledBool")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_NPN_GetValue_NPNVjavascriptEnabledBool(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NPN_GetValue_NPNVisOfflineBool :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_NPN_GetValue_NPNVisOfflineBool__ID
    };
    Msg_NPN_GetValue_NPNVisOfflineBool() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_NPN_GetValue_NPNVisOfflineBool")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPN_GetValue_NPNVisOfflineBool(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_NPN_GetValue_NPNVisOfflineBool :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_NPN_GetValue_NPNVisOfflineBool__ID
    };
    Reply_NPN_GetValue_NPNVisOfflineBool() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_NPN_GetValue_NPNVisOfflineBool")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_NPN_GetValue_NPNVisOfflineBool(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NPN_GetValue_NPNVWindowNPObject :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_NPN_GetValue_NPNVWindowNPObject__ID
    };
    Msg_NPN_GetValue_NPNVWindowNPObject() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_NPN_GetValue_NPNVWindowNPObject")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPN_GetValue_NPNVWindowNPObject(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_NPN_GetValue_NPNVWindowNPObject :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_NPN_GetValue_NPNVWindowNPObject__ID
    };
    Reply_NPN_GetValue_NPNVWindowNPObject() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_NPN_GetValue_NPNVWindowNPObject")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_NPN_GetValue_NPNVWindowNPObject(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NPN_GetValue_NPNVPluginElementNPObject :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_NPN_GetValue_NPNVPluginElementNPObject__ID
    };
    Msg_NPN_GetValue_NPNVPluginElementNPObject() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_NPN_GetValue_NPNVPluginElementNPObject")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPN_GetValue_NPNVPluginElementNPObject(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_NPN_GetValue_NPNVPluginElementNPObject :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_NPN_GetValue_NPNVPluginElementNPObject__ID
    };
    Reply_NPN_GetValue_NPNVPluginElementNPObject() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_NPN_GetValue_NPNVPluginElementNPObject")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_NPN_GetValue_NPNVPluginElementNPObject(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NPN_GetValue_NPNVprivateModeBool :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_NPN_GetValue_NPNVprivateModeBool__ID
    };
    Msg_NPN_GetValue_NPNVprivateModeBool() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_NPN_GetValue_NPNVprivateModeBool")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPN_GetValue_NPNVprivateModeBool(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_NPN_GetValue_NPNVprivateModeBool :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_NPN_GetValue_NPNVprivateModeBool__ID
    };
    Reply_NPN_GetValue_NPNVprivateModeBool() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_NPN_GetValue_NPNVprivateModeBool")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_NPN_GetValue_NPNVprivateModeBool(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NPN_GetValue_NPNVnetscapeWindow :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_NPN_GetValue_NPNVnetscapeWindow__ID
    };
    Msg_NPN_GetValue_NPNVnetscapeWindow() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_NPN_GetValue_NPNVnetscapeWindow")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPN_GetValue_NPNVnetscapeWindow(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_NPN_GetValue_NPNVnetscapeWindow :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_NPN_GetValue_NPNVnetscapeWindow__ID
    };
    Reply_NPN_GetValue_NPNVnetscapeWindow() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_NPN_GetValue_NPNVnetscapeWindow")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_NPN_GetValue_NPNVnetscapeWindow(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NPN_SetValue_NPPVpluginWindow :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_NPN_SetValue_NPPVpluginWindow__ID
    };
    Msg_NPN_SetValue_NPPVpluginWindow() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_NPN_SetValue_NPPVpluginWindow")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPN_SetValue_NPPVpluginWindow(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_NPN_SetValue_NPPVpluginWindow :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_NPN_SetValue_NPPVpluginWindow__ID
    };
    Reply_NPN_SetValue_NPPVpluginWindow() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_NPN_SetValue_NPPVpluginWindow")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_NPN_SetValue_NPPVpluginWindow(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NPN_SetValue_NPPVpluginTransparent :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_NPN_SetValue_NPPVpluginTransparent__ID
    };
    Msg_NPN_SetValue_NPPVpluginTransparent() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_NPN_SetValue_NPPVpluginTransparent")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPN_SetValue_NPPVpluginTransparent(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_NPN_SetValue_NPPVpluginTransparent :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_NPN_SetValue_NPPVpluginTransparent__ID
    };
    Reply_NPN_SetValue_NPPVpluginTransparent() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_NPN_SetValue_NPPVpluginTransparent")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_NPN_SetValue_NPPVpluginTransparent(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NPN_SetValue_NPPVpluginUsesDOMForCursor :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_NPN_SetValue_NPPVpluginUsesDOMForCursor__ID
    };
    Msg_NPN_SetValue_NPPVpluginUsesDOMForCursor() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_NPN_SetValue_NPPVpluginUsesDOMForCursor")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPN_SetValue_NPPVpluginUsesDOMForCursor(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_NPN_SetValue_NPPVpluginUsesDOMForCursor :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_NPN_SetValue_NPPVpluginUsesDOMForCursor__ID
    };
    Reply_NPN_SetValue_NPPVpluginUsesDOMForCursor() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_NPN_SetValue_NPPVpluginUsesDOMForCursor")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_NPN_SetValue_NPPVpluginUsesDOMForCursor(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NPN_SetValue_NPPVpluginDrawingModel :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_NPN_SetValue_NPPVpluginDrawingModel__ID
    };
    Msg_NPN_SetValue_NPPVpluginDrawingModel() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_NPN_SetValue_NPPVpluginDrawingModel")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPN_SetValue_NPPVpluginDrawingModel(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_NPN_SetValue_NPPVpluginDrawingModel :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_NPN_SetValue_NPPVpluginDrawingModel__ID
    };
    Reply_NPN_SetValue_NPPVpluginDrawingModel() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_NPN_SetValue_NPPVpluginDrawingModel")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_NPN_SetValue_NPPVpluginDrawingModel(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NPN_SetValue_NPPVpluginEventModel :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_NPN_SetValue_NPPVpluginEventModel__ID
    };
    Msg_NPN_SetValue_NPPVpluginEventModel() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_NPN_SetValue_NPPVpluginEventModel")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPN_SetValue_NPPVpluginEventModel(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_NPN_SetValue_NPPVpluginEventModel :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_NPN_SetValue_NPPVpluginEventModel__ID
    };
    Reply_NPN_SetValue_NPPVpluginEventModel() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_NPN_SetValue_NPPVpluginEventModel")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_NPN_SetValue_NPPVpluginEventModel(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NPN_GetURL :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_NPN_GetURL__ID
    };
    Msg_NPN_GetURL() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_NPN_GetURL")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPN_GetURL(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_NPN_GetURL :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_NPN_GetURL__ID
    };
    Reply_NPN_GetURL() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_NPN_GetURL")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_NPN_GetURL(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NPN_PostURL :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_NPN_PostURL__ID
    };
    Msg_NPN_PostURL() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_NPN_PostURL")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPN_PostURL(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_NPN_PostURL :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_NPN_PostURL__ID
    };
    Reply_NPN_PostURL() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_NPN_PostURL")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_NPN_PostURL(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_PStreamNotifyConstructor :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_PStreamNotifyConstructor__ID
    };
    Msg_PStreamNotifyConstructor() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_PStreamNotifyConstructor")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_PStreamNotifyConstructor(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_PStreamNotifyConstructor :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_PStreamNotifyConstructor__ID
    };
    Reply_PStreamNotifyConstructor() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_PStreamNotifyConstructor")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_PStreamNotifyConstructor(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NPN_InvalidateRect :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_NPN_InvalidateRect__ID
    };
    Msg_NPN_InvalidateRect() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_NPN_InvalidateRect")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPN_InvalidateRect(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_Show :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_Show__ID
    };
    Msg_Show() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_Show")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_Show(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_Show :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_Show__ID
    };
    Reply_Show() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_Show")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_Show(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_PPluginSurfaceConstructor :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_PPluginSurfaceConstructor__ID
    };
    Msg_PPluginSurfaceConstructor() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_PPluginSurfaceConstructor")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_PPluginSurfaceConstructor(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_PPluginSurfaceConstructor :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_PPluginSurfaceConstructor__ID
    };
    Reply_PPluginSurfaceConstructor() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_PPluginSurfaceConstructor")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_PPluginSurfaceConstructor(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NPN_PushPopupsEnabledState :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_NPN_PushPopupsEnabledState__ID
    };
    Msg_NPN_PushPopupsEnabledState() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_NPN_PushPopupsEnabledState")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPN_PushPopupsEnabledState(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_NPN_PushPopupsEnabledState :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_NPN_PushPopupsEnabledState__ID
    };
    Reply_NPN_PushPopupsEnabledState() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_NPN_PushPopupsEnabledState")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_NPN_PushPopupsEnabledState(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NPN_PopPopupsEnabledState :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_NPN_PopPopupsEnabledState__ID
    };
    Msg_NPN_PopPopupsEnabledState() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_NPN_PopPopupsEnabledState")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPN_PopPopupsEnabledState(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_NPN_PopPopupsEnabledState :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_NPN_PopPopupsEnabledState__ID
    };
    Reply_NPN_PopPopupsEnabledState() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_NPN_PopPopupsEnabledState")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_NPN_PopPopupsEnabledState(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NPN_GetValueForURL :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_NPN_GetValueForURL__ID
    };
    Msg_NPN_GetValueForURL() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_NPN_GetValueForURL")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPN_GetValueForURL(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_NPN_GetValueForURL :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_NPN_GetValueForURL__ID
    };
    Reply_NPN_GetValueForURL() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_NPN_GetValueForURL")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_NPN_GetValueForURL(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NPN_SetValueForURL :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_NPN_SetValueForURL__ID
    };
    Msg_NPN_SetValueForURL() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_NPN_SetValueForURL")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPN_SetValueForURL(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_NPN_SetValueForURL :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_NPN_SetValueForURL__ID
    };
    Reply_NPN_SetValueForURL() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_NPN_SetValueForURL")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_NPN_SetValueForURL(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NPN_GetAuthenticationInfo :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_NPN_GetAuthenticationInfo__ID
    };
    Msg_NPN_GetAuthenticationInfo() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_NPN_GetAuthenticationInfo")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPN_GetAuthenticationInfo(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_NPN_GetAuthenticationInfo :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_NPN_GetAuthenticationInfo__ID
    };
    Reply_NPN_GetAuthenticationInfo() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_NPN_GetAuthenticationInfo")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_NPN_GetAuthenticationInfo(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NPN_ConvertPoint :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_NPN_ConvertPoint__ID
    };
    Msg_NPN_ConvertPoint() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_NPN_ConvertPoint")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPN_ConvertPoint(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_NPN_ConvertPoint :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_NPN_ConvertPoint__ID
    };
    Reply_NPN_ConvertPoint() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_NPN_ConvertPoint")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_NPN_ConvertPoint(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_NegotiatedCarbon :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_NegotiatedCarbon__ID
    };
    Msg_NegotiatedCarbon() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_NegotiatedCarbon")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NegotiatedCarbon(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_NegotiatedCarbon :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_NegotiatedCarbon__ID
    };
    Reply_NegotiatedCarbon() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_NegotiatedCarbon")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_NegotiatedCarbon(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_PPluginScriptableObjectConstructor :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_PPluginScriptableObjectConstructor__ID
    };
    Msg_PPluginScriptableObjectConstructor() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_PPluginScriptableObjectConstructor")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_PPluginScriptableObjectConstructor(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_PPluginScriptableObjectConstructor :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_PPluginScriptableObjectConstructor__ID
    };
    Reply_PPluginScriptableObjectConstructor() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_PPluginScriptableObjectConstructor")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_PPluginScriptableObjectConstructor(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_PBrowserStreamConstructor :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_PBrowserStreamConstructor__ID
    };
    Msg_PBrowserStreamConstructor() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_PBrowserStreamConstructor")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_PBrowserStreamConstructor(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_PBrowserStreamConstructor :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_PBrowserStreamConstructor__ID
    };
    Reply_PBrowserStreamConstructor() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_PBrowserStreamConstructor")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_PBrowserStreamConstructor(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_PPluginStreamConstructor :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_PPluginStreamConstructor__ID
    };
    Msg_PPluginStreamConstructor() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_PPluginStreamConstructor")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_PPluginStreamConstructor(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_PPluginStreamConstructor :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_PPluginStreamConstructor__ID
    };
    Reply_PPluginStreamConstructor() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_PPluginStreamConstructor")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_PPluginStreamConstructor(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_PluginFocusChange :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_PluginFocusChange__ID
    };
    Msg_PluginFocusChange() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_PluginFocusChange")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_PluginFocusChange(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_PluginFocusChange :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_PluginFocusChange__ID
    };
    Reply_PluginFocusChange() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_PluginFocusChange")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_PluginFocusChange(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_SetPluginFocus :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_SetPluginFocus__ID
    };
    Msg_SetPluginFocus() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_SetPluginFocus")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_SetPluginFocus(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_SetPluginFocus :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_SetPluginFocus__ID
    };
    Reply_SetPluginFocus() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_SetPluginFocus")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_SetPluginFocus(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_UpdateWindow :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_UpdateWindow__ID
    };
    Msg_UpdateWindow() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_UpdateWindow")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_UpdateWindow(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_UpdateWindow :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_UpdateWindow__ID
    };
    Reply_UpdateWindow() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_UpdateWindow")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_UpdateWindow(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_PPluginBackgroundDestroyerConstructor :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Msg_PPluginBackgroundDestroyerConstructor__ID
    };
    Msg_PPluginBackgroundDestroyerConstructor() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Msg_PPluginBackgroundDestroyerConstructor")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_PPluginBackgroundDestroyerConstructor(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_PPluginBackgroundDestroyerConstructor :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::plugins::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::NativeWindowHandle NativeWindowHandle;
    typedef mozilla::gfxSurfaceType gfxSurfaceType;
    typedef mozilla::null_t null_t;
    typedef mozilla::plugins::WindowsSharedMemoryHandle WindowsSharedMemoryHandle;

public:
    enum {
        ID = Reply_PPluginBackgroundDestroyerConstructor__ID
    };
    Reply_PPluginBackgroundDestroyerConstructor() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginInstance::Reply_PPluginBackgroundDestroyerConstructor")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_PPluginBackgroundDestroyerConstructor(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};



} // namespace PPluginInstance
} // namespace plugins
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct SurfaceDescriptorX11|
//
namespace mozilla {
namespace plugins {
inline SurfaceDescriptorX11::SurfaceDescriptorX11()
{
    Init();
}

inline SurfaceDescriptorX11::~SurfaceDescriptorX11()
{
}

inline bool
SurfaceDescriptorX11::operator==(const SurfaceDescriptorX11& _o) const
{
    if ((!((XID()) == ((_o).XID())))) {
        return false;
    }
    if ((!((xrenderPictID()) == ((_o).xrenderPictID())))) {
        return false;
    }
    if ((!((size()) == ((_o).size())))) {
        return false;
    }
    return true;
}

inline void
SurfaceDescriptorX11::Init()
{
}

inline void
SurfaceDescriptorX11::Assign(
        const int& _XID,
        const int& _xrenderPictID,
        const gfxIntSize& _size)
{
    XID_ = _XID;
    xrenderPictID_ = _xrenderPictID;
    size_ = _size;
}

} // namespace plugins
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union SurfaceDescriptor|
//
namespace mozilla {
namespace plugins {
inline bool
SurfaceDescriptor::MaybeDestroy(Type aNewType)
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case TShmem:
        {
            (ptr_Shmem())->~Shmem__tdef();
            break;
        }
    case TSurfaceDescriptorX11:
        {
            (ptr_SurfaceDescriptorX11())->~SurfaceDescriptorX11__tdef();
            break;
        }
    case TPPluginSurfaceParent:
        {
            (ptr_PPluginSurfaceParent())->~PPluginSurfaceParent__tdef();
            break;
        }
    case TPPluginSurfaceChild:
        {
            (ptr_PPluginSurfaceChild())->~PPluginSurfaceChild__tdef();
            break;
        }
    case Tnull_t:
        {
            (ptr_null_t())->~null_t__tdef();
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("not reached");
            break;
        }
    }
    return true;
}

inline SurfaceDescriptor::SurfaceDescriptor(Shmem& aOther)
{
    new (ptr_Shmem()) Shmem(aOther);
    mType = TShmem;
}

inline SurfaceDescriptor::SurfaceDescriptor(const SurfaceDescriptorX11& aOther)
{
    new (ptr_SurfaceDescriptorX11()) SurfaceDescriptorX11(aOther);
    mType = TSurfaceDescriptorX11;
}

inline SurfaceDescriptor::SurfaceDescriptor(PPluginSurfaceParent* aOther)
{
    new (ptr_PPluginSurfaceParent()) PPluginSurfaceParent*(const_cast<PPluginSurfaceParent*>(aOther));
    mType = TPPluginSurfaceParent;
}

inline SurfaceDescriptor::SurfaceDescriptor(PPluginSurfaceChild* aOther)
{
    new (ptr_PPluginSurfaceChild()) PPluginSurfaceChild*(const_cast<PPluginSurfaceChild*>(aOther));
    mType = TPPluginSurfaceChild;
}

inline SurfaceDescriptor::SurfaceDescriptor(const null_t& aOther)
{
    new (ptr_null_t()) null_t(aOther);
    mType = Tnull_t;
}

inline SurfaceDescriptor::SurfaceDescriptor(const SurfaceDescriptor& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case TShmem:
        {
            new (ptr_Shmem()) Shmem((aOther).get_Shmem());
            break;
        }
    case TSurfaceDescriptorX11:
        {
            new (ptr_SurfaceDescriptorX11()) SurfaceDescriptorX11((aOther).get_SurfaceDescriptorX11());
            break;
        }
    case TPPluginSurfaceParent:
        {
            new (ptr_PPluginSurfaceParent()) PPluginSurfaceParent*(const_cast<PPluginSurfaceParent*>((aOther).get_PPluginSurfaceParent()));
            break;
        }
    case TPPluginSurfaceChild:
        {
            new (ptr_PPluginSurfaceChild()) PPluginSurfaceChild*(const_cast<PPluginSurfaceChild*>((aOther).get_PPluginSurfaceChild()));
            break;
        }
    case Tnull_t:
        {
            new (ptr_null_t()) null_t((aOther).get_null_t());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

inline SurfaceDescriptor::~SurfaceDescriptor()
{
    MaybeDestroy(T__None);
}

inline SurfaceDescriptor&
SurfaceDescriptor::operator=(Shmem& aRhs)
{
    if (MaybeDestroy(TShmem)) {
        new (ptr_Shmem()) Shmem;
    }
    (*(ptr_Shmem())) = aRhs;
    mType = TShmem;
    return (*(this));
}

inline SurfaceDescriptor&
SurfaceDescriptor::operator=(const SurfaceDescriptorX11& aRhs)
{
    if (MaybeDestroy(TSurfaceDescriptorX11)) {
        new (ptr_SurfaceDescriptorX11()) SurfaceDescriptorX11;
    }
    (*(ptr_SurfaceDescriptorX11())) = aRhs;
    mType = TSurfaceDescriptorX11;
    return (*(this));
}

inline SurfaceDescriptor&
SurfaceDescriptor::operator=(PPluginSurfaceParent* aRhs)
{
    if (MaybeDestroy(TPPluginSurfaceParent)) {
        new (ptr_PPluginSurfaceParent()) PPluginSurfaceParent*;
    }
    (*(ptr_PPluginSurfaceParent())) = const_cast<PPluginSurfaceParent*>(aRhs);
    mType = TPPluginSurfaceParent;
    return (*(this));
}

inline SurfaceDescriptor&
SurfaceDescriptor::operator=(PPluginSurfaceChild* aRhs)
{
    if (MaybeDestroy(TPPluginSurfaceChild)) {
        new (ptr_PPluginSurfaceChild()) PPluginSurfaceChild*;
    }
    (*(ptr_PPluginSurfaceChild())) = const_cast<PPluginSurfaceChild*>(aRhs);
    mType = TPPluginSurfaceChild;
    return (*(this));
}

inline SurfaceDescriptor&
SurfaceDescriptor::operator=(const null_t& aRhs)
{
    if (MaybeDestroy(Tnull_t)) {
        new (ptr_null_t()) null_t;
    }
    (*(ptr_null_t())) = aRhs;
    mType = Tnull_t;
    return (*(this));
}

inline SurfaceDescriptor&
SurfaceDescriptor::operator=(const SurfaceDescriptor& aRhs)
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TShmem:
        {
            if (MaybeDestroy(t)) {
                new (ptr_Shmem()) Shmem;
            }
            (*(ptr_Shmem())) = (aRhs).get_Shmem();
            break;
        }
    case TSurfaceDescriptorX11:
        {
            if (MaybeDestroy(t)) {
                new (ptr_SurfaceDescriptorX11()) SurfaceDescriptorX11;
            }
            (*(ptr_SurfaceDescriptorX11())) = (aRhs).get_SurfaceDescriptorX11();
            break;
        }
    case TPPluginSurfaceParent:
        {
            if (MaybeDestroy(t)) {
                new (ptr_PPluginSurfaceParent()) PPluginSurfaceParent*;
            }
            (*(ptr_PPluginSurfaceParent())) = const_cast<PPluginSurfaceParent*>((aRhs).get_PPluginSurfaceParent());
            break;
        }
    case TPPluginSurfaceChild:
        {
            if (MaybeDestroy(t)) {
                new (ptr_PPluginSurfaceChild()) PPluginSurfaceChild*;
            }
            (*(ptr_PPluginSurfaceChild())) = const_cast<PPluginSurfaceChild*>((aRhs).get_PPluginSurfaceChild());
            break;
        }
    case Tnull_t:
        {
            if (MaybeDestroy(t)) {
                new (ptr_null_t()) null_t;
            }
            (*(ptr_null_t())) = (aRhs).get_null_t();
            break;
        }
    case T__None:
        {
            MaybeDestroy(t);
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

inline bool
SurfaceDescriptor::operator==(Shmem& aRhs) const
{
    return (get_Shmem()) == (aRhs);
}

inline bool
SurfaceDescriptor::operator==(const SurfaceDescriptorX11& aRhs) const
{
    return (get_SurfaceDescriptorX11()) == (aRhs);
}

inline bool
SurfaceDescriptor::operator==(PPluginSurfaceParent* aRhs) const
{
    return (get_PPluginSurfaceParent()) == (aRhs);
}

inline bool
SurfaceDescriptor::operator==(PPluginSurfaceChild* aRhs) const
{
    return (get_PPluginSurfaceChild()) == (aRhs);
}

inline bool
SurfaceDescriptor::operator==(const null_t& aRhs) const
{
    return (get_null_t()) == (aRhs);
}

inline bool
SurfaceDescriptor::operator==(const SurfaceDescriptor& aRhs) const
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case TShmem:
        {
            return (get_Shmem()) == ((aRhs).get_Shmem());
        }
    case TSurfaceDescriptorX11:
        {
            return (get_SurfaceDescriptorX11()) == ((aRhs).get_SurfaceDescriptorX11());
        }
    case TPPluginSurfaceParent:
        {
            return (get_PPluginSurfaceParent()) == ((aRhs).get_PPluginSurfaceParent());
        }
    case TPPluginSurfaceChild:
        {
            return (get_PPluginSurfaceChild()) == ((aRhs).get_PPluginSurfaceChild());
        }
    case Tnull_t:
        {
            return (get_null_t()) == ((aRhs).get_null_t());
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            return false;
        }
    }
}

} // namespace plugins
} // namespace mozilla

#endif // ifndef PPluginInstance_h
